# $Id: proxy.py,v 1.6 2011/05/04 07:33:05 irees Exp $
import copy
import urllib
import urlparse
import itertools
import xmlrpclib
import random
import time
import UserDict, collections
collections.Mapping.register(UserDict.DictMixin)

from hashlib import sha1

import jsonrpc.proxy




##################################
# Moved from clients/emen2proxy
##################################


def zipdicts(*dicts):
	keydict = dicts[0]
	for k in keydict.iterkeys():
		yield (k, tuple(dict_.get(k) for dict_ in dicts))



# def newrecord(rec):
# 	r = emen2.db.record.Record(rec)
# 	return r



def newthing(typ):
	def _inner(data):
		a = object.__new__(typ)
		a.update(data)
		return a
	return _inner




class Context(object):
	def __init__(self, ctxid, host):
		self.ctxid = ctxid
		self.host = host
		self.db = None





##################################
# Main exported DB interface classes
##################################



# JSONRPCProxy customized for EMEN2

class EMEN2JSONRPCProxy(jsonrpc.proxy.JSONRPCProxy):
	def init(self, ctxid=None, t=False, *args, **kwargs):
		self._ctx = Context(ctxid, self.serviceURL)
		self._host = self.serviceURL
		self._ctx.db = self
		self._convert = True
		self._t = t

	# def _transformURL(self, url, path):
	# 	if self._t:
	# 		path = '/?'.join([path, 't=1'])
	# 	return url, path

	typemapping = dict(
		set = set,
		tuple = tuple,
		# record = newrecord,
		# paramdef = newthing(emen2.db.paramdef.ParamDef),
		# recorddef = newthing(emen2.db.recorddef.RecordDef),
		# user = newthing(emen2.db.user.User)
	)
	revmap = dict( (y,x) for x,y in typemapping.iteritems() )


	def _restore_from_typemap(self, typemap, val):
		result = val
		containertype = None
		if isinstance(typemap, list):
			result = {}
			for k, (vv, tv) in zipdicts(val, typemap[1]):
				result[k] = self._restore_from_typemap(tv, vv)
			containertype=self.typemapping.get(typemap[0])
		else:
			containertype=self.typemapping.get(typemap)
		if containertype is not None:
			result = containertype(result)
		return result


	def __getattr__(self, name):
		result = jsonrpc.proxy.JSONRPCProxy.__getattr__(self, name)
		result._setContext(self._ctx.ctxid)
		return result


	def _setContext(self, ctxid):
		self._ctx.ctxid = ctxid


	def _get_postdata(self, args, kwargs):
		if self._ctx.ctxid:
			kwargs['ctxid'] = self._ctx.ctxid
		return jsonrpc.proxy.JSONRPCProxy._get_postdata(self, args, kwargs)


	def _proc_response(self, data):
		result = copy.deepcopy(data['result'])
		typemap = copy.deepcopy(data.get('type'))
		if typemap:
			result = self._restore_from_typemap(typemap, result)
		result = dict(
			result = result
		)
		return result


	def login(self, name, password):
		self._ctx.ctxid = self._call('login', name, password)




__version__ = "$Revision: 1.6 $".split(":")[1][:-1].strip()

