<%page expression_filter="x"/>
<%
PROJECT_TYPE_MAP = {"Technical_Core":"T","Dissemination":"D","Collaboration":"C","Service":"S"}
PUBLICATION_RECTYPE_MAP = {"publication":"J", "publication_abstract":"A", "publication_book":"B"}
YES_NO_MAP = {None:"N",0:"N",1:"Y","0":"N","1":"Y"}
%>
<P41_Progress_Report xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns="http://sis.ncrr.nih.gov" xsi:schemaLocation="http://sis.ncrr.nih.gov http://APRSIS.NCRR.NIH.GOV/XML/p41_progress_report.xsd">

<Grant_Info>
	<Serial_Number>${str(root["p41_serial"]).zfill(6)}</Serial_Number>
	<Fiscal_Year>${root['p41_year']+1}</Fiscal_Year>
	<Reporting_To_Date>${root["p41_report_end_date"].replace("/","-")}</Reporting_To_Date>
	<Reporting_From_Date>${root["p41_report_start_date"].replace("/","-")}</Reporting_From_Date>
	<Project_Title>${root["p41_title"]}</Project_Title>
	<Recipient_Institution_Name>${root["institution"]}</Recipient_Institution_Name>
	<Activity_Code>P41</Activity_Code>
	<Director_Person_ID>${users.get(root["grant_pi"]).record}</Director_Person_ID>
	<Patent_Or_Copyright_Award>N</Patent_Or_Copyright_Award>
</Grant_Info>


% for user in users.values():

<Person Person_ID="${user.record}">
	<Last_Name>${user.userrec['name_last']}</Last_Name>
	<First_Name>${user.userrec['name_first']}</First_Name>
	<Full_Name>${user.displayname}</Full_Name>

	% for degree in user.userrec.get('academic_degrees', []):
	<Academic_Degree>${degree.upper()}</Academic_Degree>		
	% endfor

	${iftag('Phone_Number', user.userrec.get('phone_voice'))}
	${iftag('Fax_Number', user.userrec.get('phone_fax'))}
	${iftag('Email_Address', user.email)}
	${iftag('Department', user.userrec.get('department'))}

	% if user.userrec.get('institution','').lower() not in ['baylor college of medicine', 'bcm'] and user.userrec.get('institution'):

	${iftag('Nonhost_Name', user.userrec.get('institution',''))}

		% if user.userrec.get('country', '').lower() in ['us', 'usa'] or user.userrec.get('country', '').lower().startswith('united states'):

	${iftag('Nonhost_State', user.userrec.get('address_state', '').upper())}
	<Nonhost_Country>USA</Nonhost_Country>
		% else:
	<Nonhost_Country>${user.userrec.get('country')}</Nonhost_Country>
		% endif

	% endif	
	
	% for grant in grantsbyuser.get(user.name, []):
		% if grant['grant_source'] == 'NIH':

	<Federal_PHS_Funding>
		<Organization>${grant['grant_source']}</Organization>
				% for project in projectsbygrant.get(grant.name, []):
		<Sub_ID>${project}</Sub_ID>
				% endfor
		<Grant_Or_Contract_Number>${grant['grant_number']}</Grant_Or_Contract_Number>
		<Total_Support_Funds>${grant.get('grant_funds', 0)}</Total_Support_Funds>
	</Federal_PHS_Funding>									

		% elif grant['grant_source'] == 'USA_Federal':		

	<Federal_Non_PHS_Funding>
		<Organization>${grant['grant_source']}</Organization>
				% for project in projectsbygrant.get(grant.name, []):
					<Sub_ID>${project}</Sub_ID>
				% endfor					
		<Grant_Or_Contract_Number>${grant['grant_number']}</Grant_Or_Contract_Number>
		<Total_Support_Funds>${grant.get('grant_funds', 0)}</Total_Support_Funds>
	</Federal_Non_PHS_Funding>							

		% else:
				
	<Non_Federal_Funding>
				% if grant['grant_source_type'] == 'Industry':
		<Source_Type>IND</Source_Type>
				% else:
		<Source_Type>FDN</Source_Type>
				% endif
				
				% for project in projectsbygrant.get(grant.name, []):
		<Sub_ID>${project}</Sub_ID>
				% endfor				

		<Organization_Name>${grant['grant_source']}</Organization_Name>
		<Grant_Or_Contract_Number>${grant['grant_number']}</Grant_Or_Contract_Number>
		<Total_Support_Funds>${grant.get('grant_funds', 0)}</Total_Support_Funds>
	</Non_Federal_Funding>

		% endif
	% endfor
	
</Person>

% endfor


% for project in p41_projects:

<Subproject Sub_ID="${project.name}">
	<Subproject_ID>${project['p41_subprojectid']}</Subproject_ID>
	<Title>${project['p41_project_title']}</Title>
	<AIDS_Flag>N</AIDS_Flag>
	<Abstract>${project['p41_abstract']}</Abstract>
	<Type>${PROJECT_TYPE_MAP[project['p41_project_type']]}</Type>
	<Progress>${project['p41_progress']}</Progress>

	<Investigator>
		<Person_ID>${users[project['p41_project_pi']].record}</Person_ID>
		<Investigator_Type>P</Investigator_Type>
	</Investigator>

	% for investigator in project.get("p41_project_investigators", []):
		% if investigator != project['p41_project_pi']:
	<Investigator>
		<Person_ID>${users[investigator].record}</Person_ID>
		<Investigator_Type>C</Investigator_Type>
	</Investigator>
		% endif
	% endfor

	% for pub in pubsbyproject.get(project.name, []):
	<Publication_ID>${pub}</Publication_ID>
	% endfor

	<Percent_Grant_Dollars>${project.get('p41_percent',0)}</Percent_Grant_Dollars>
</Subproject>

% endfor


% for pub in pubs:

<Publication Publication_ID="${pub.name}">
	<Publication_Type>${PUBLICATION_RECTYPE_MAP[pub.rectype]}</Publication_Type>
	<In_Press>${YES_NO_MAP[pub.get('publication_in_press')]}</In_Press>		
	<Resource_Acknowledged>Y</Resource_Acknowledged>

	% if pub.get('pmid') or pub.get('pmcid'):
	<PM_UID>${pub['pmid']}</PM_UID>
	% else:
	<Body>${pub_body(pub)}</Body>
	% endif

</Publication>

% endfor


</P41_Progress_Report>



<%def name="iftag(tag, value)"> 
% if value not in ["None", None, ""]:
<${tag}>${value}</${tag}>
% endif
</%def>



<%def name="pub_body(p)"> 
<%
body = 'Unknown Publication Type'
if p.rectype == 'publication':
	body = "%s (%s). %s. %s, %s:%s."%(", ".join(p["author_list"]),p["journal_date"],p["title_publication"],p["name_journal"],p["journal_volume"],p["page_range"])
elif p.rectype == 'publication_abstract':
	body = "%s (%s). %s. %s. %s."%(", ".join(p.get("author_list",[])),p["year_published"],p["title_publication"],p["name_conference"],p["city_conference"])
elif p.rectype == 'publication_book':
	body="%s (%s). "%(", ".join(p["author_list"]), p["year_published"])
	if p["name_chapter"] and len(p["name_chapter"])>2 : body+="%s. In:"%p["name_chapter"]
	body+=" %s."%p["name_book"]
	if p["author_editor_list"] and len(p["author_editor_list"])>0 :
		body+=", ".join(p["author_editor_list"])+" (ed)."
	if p["publisher"] : body+=p["publisher"]+'.'
	else: print "Unknown Publisher %d"%i
%>
${body}
</%def>


